diff --git a/gcc/rust/hir/rust-ast-lower-base.cc b/gcc/rust/hir/rust-ast-lower-base.cc
index f8438557707..748cec74829 100644
--- a/gcc/rust/hir/rust-ast-lower-base.cc
+++ b/gcc/rust/hir/rust-ast-lower-base.cc
@@ -530,16 +530,24 @@ ASTLoweringBase::visit (AST::SelfParam &param)
 {}
 
 HIR::Lifetime
-ASTLoweringBase::lower_lifetime (AST::Lifetime &lifetime)
+ASTLoweringBase::lower_lifetime (AST::Lifetime &lifetime,
+				 bool default_to_static_lifetime)
 {
+  auto lifetime_type = lifetime.get_lifetime_type ();
+  if (lifetime_type == AST::Lifetime::WILDCARD && default_to_static_lifetime)
+    {
+      // If compiling in a static context.
+      lifetime_type = AST::Lifetime::STATIC;
+    }
+
   auto crate_num = mappings->get_current_crate ();
   Analysis::NodeMapping mapping (crate_num, lifetime.get_node_id (),
 				 mappings->get_next_hir_id (crate_num),
 				 UNKNOWN_LOCAL_DEFID);
   mappings->insert_node_to_hir (mapping.get_nodeid (), mapping.get_hirid ());
 
-  return HIR::Lifetime (mapping, lifetime.get_lifetime_type (),
-			lifetime.get_lifetime_name (), lifetime.get_locus ());
+  return HIR::Lifetime (mapping, lifetime_type, lifetime.get_lifetime_name (),
+			lifetime.get_locus ());
 }
 
 HIR::LoopLabel
diff --git a/gcc/rust/hir/rust-ast-lower-base.h b/gcc/rust/hir/rust-ast-lower-base.h
index d52afd3421f..8da11750d18 100644
--- a/gcc/rust/hir/rust-ast-lower-base.h
+++ b/gcc/rust/hir/rust-ast-lower-base.h
@@ -264,7 +264,8 @@ protected:
   Analysis::Mappings *mappings;
   Analysis::BuiltinAttributeMappings *attr_mappings;
 
-  HIR::Lifetime lower_lifetime (AST::Lifetime &lifetime);
+  HIR::Lifetime lower_lifetime (AST::Lifetime &lifetime,
+				bool default_to_static_lifetime = false);
 
   HIR::LoopLabel lower_loop_label (AST::LoopLabel &loop_label);
 
diff --git a/gcc/rust/hir/rust-ast-lower-implitem.h b/gcc/rust/hir/rust-ast-lower-implitem.h
index 6f904dde19f..81dae14cdca 100644
--- a/gcc/rust/hir/rust-ast-lower-implitem.h
+++ b/gcc/rust/hir/rust-ast-lower-implitem.h
@@ -88,7 +88,8 @@ public:
   {
     HIR::Visibility vis = translate_visibility (constant.get_visibility ());
 
-    HIR::Type *type = ASTLoweringType::translate (constant.get_type ().get ());
+    HIR::Type *type
+      = ASTLoweringType::translate (constant.get_type ().get (), true);
     HIR::Expr *expr = ASTLoweringExpr::translate (constant.get_expr ().get ());
 
     auto crate_num = mappings->get_current_crate ();
diff --git a/gcc/rust/hir/rust-ast-lower-item.cc b/gcc/rust/hir/rust-ast-lower-item.cc
index 2895872f336..7ef556fee0d 100644
--- a/gcc/rust/hir/rust-ast-lower-item.cc
+++ b/gcc/rust/hir/rust-ast-lower-item.cc
@@ -351,7 +351,7 @@ ASTLoweringItem::visit (AST::StaticItem &var)
 {
   HIR::Visibility vis = translate_visibility (var.get_visibility ());
 
-  HIR::Type *type = ASTLoweringType::translate (var.get_type ().get ());
+  HIR::Type *type = ASTLoweringType::translate (var.get_type ().get (), true);
   HIR::Expr *expr = ASTLoweringExpr::translate (var.get_expr ().get ());
 
   auto crate_num = mappings->get_current_crate ();
@@ -372,7 +372,8 @@ ASTLoweringItem::visit (AST::ConstantItem &constant)
 {
   HIR::Visibility vis = translate_visibility (constant.get_visibility ());
 
-  HIR::Type *type = ASTLoweringType::translate (constant.get_type ().get ());
+  HIR::Type *type
+    = ASTLoweringType::translate (constant.get_type ().get (), true);
   HIR::Expr *expr = ASTLoweringExpr::translate (constant.get_expr ().get ());
 
   auto crate_num = mappings->get_current_crate ();
diff --git a/gcc/rust/hir/rust-ast-lower-type.cc b/gcc/rust/hir/rust-ast-lower-type.cc
index 5388f2139ce..5cea71f83a2 100644
--- a/gcc/rust/hir/rust-ast-lower-type.cc
+++ b/gcc/rust/hir/rust-ast-lower-type.cc
@@ -180,9 +180,9 @@ ASTLowerQualifiedPathInType::visit (AST::QualifiedPathInType &path)
 }
 
 HIR::Type *
-ASTLoweringType::translate (AST::Type *type)
+ASTLoweringType::translate (AST::Type *type, bool default_to_static_lifetime)
 {
-  ASTLoweringType resolver;
+  ASTLoweringType resolver (default_to_static_lifetime);
   type->accept_vis (resolver);
 
   rust_assert (resolver.translated != nullptr);
@@ -222,7 +222,8 @@ ASTLoweringType::visit (AST::BareFunctionType &fntype)
 	}
 
       HIR::Type *param_type
-	= ASTLoweringType::translate (param.get_type ().get ());
+	= ASTLoweringType::translate (param.get_type ().get (),
+				      default_to_static_lifetime);
 
       HIR::MaybeNamedParam p (param.get_name (), kind,
 			      std::unique_ptr<HIR::Type> (param_type),
@@ -234,7 +235,8 @@ ASTLoweringType::visit (AST::BareFunctionType &fntype)
   if (fntype.has_return_type ())
     {
       return_type
-	= ASTLoweringType::translate (fntype.get_return_type ().get ());
+	= ASTLoweringType::translate (fntype.get_return_type ().get (),
+				      default_to_static_lifetime);
     }
 
   auto crate_num = mappings->get_current_crate ();
@@ -254,7 +256,8 @@ ASTLoweringType::visit (AST::TupleType &tuple)
   std::vector<std::unique_ptr<HIR::Type>> elems;
   for (auto &e : tuple.get_elems ())
     {
-      HIR::Type *t = ASTLoweringType::translate (e.get ());
+      HIR::Type *t
+	= ASTLoweringType::translate (e.get (), default_to_static_lifetime);
       elems.push_back (std::unique_ptr<HIR::Type> (t));
     }
 
@@ -283,7 +286,8 @@ void
 ASTLoweringType::visit (AST::ArrayType &type)
 {
   HIR::Type *translated_type
-    = ASTLoweringType::translate (type.get_elem_type ().get ());
+    = ASTLoweringType::translate (type.get_elem_type ().get (),
+				  default_to_static_lifetime);
   HIR::Expr *array_size
     = ASTLoweringExpr::translate (type.get_size_expr ().get ());
 
@@ -301,10 +305,12 @@ ASTLoweringType::visit (AST::ArrayType &type)
 void
 ASTLoweringType::visit (AST::ReferenceType &type)
 {
-  HIR::Lifetime lifetime = lower_lifetime (type.get_lifetime ());
+  HIR::Lifetime lifetime
+    = lower_lifetime (type.get_lifetime (), default_to_static_lifetime);
 
   HIR::Type *base_type
-    = ASTLoweringType::translate (type.get_base_type ().get ());
+    = ASTLoweringType::translate (type.get_base_type ().get (),
+				  default_to_static_lifetime);
 
   auto crate_num = mappings->get_current_crate ();
   Analysis::NodeMapping mapping (crate_num, type.get_node_id (),
@@ -322,7 +328,8 @@ void
 ASTLoweringType::visit (AST::RawPointerType &type)
 {
   HIR::Type *base_type
-    = ASTLoweringType::translate (type.get_type_pointed_to ().get ());
+    = ASTLoweringType::translate (type.get_type_pointed_to ().get (),
+				  default_to_static_lifetime);
 
   auto crate_num = mappings->get_current_crate ();
   Analysis::NodeMapping mapping (crate_num, type.get_node_id (),
@@ -343,7 +350,8 @@ void
 ASTLoweringType::visit (AST::SliceType &type)
 {
   HIR::Type *base_type
-    = ASTLoweringType::translate (type.get_elem_type ().get ());
+    = ASTLoweringType::translate (type.get_elem_type ().get (),
+				  default_to_static_lifetime);
 
   auto crate_num = mappings->get_current_crate ();
   Analysis::NodeMapping mapping (crate_num, type.get_node_id (),
diff --git a/gcc/rust/hir/rust-ast-lower-type.h b/gcc/rust/hir/rust-ast-lower-type.h
index 8194a9ace5e..ed90c17bb0f 100644
--- a/gcc/rust/hir/rust-ast-lower-type.h
+++ b/gcc/rust/hir/rust-ast-lower-type.h
@@ -63,7 +63,8 @@ class ASTLoweringType : public ASTLoweringBase
   using Rust::HIR::ASTLoweringBase::visit;
 
 public:
-  static HIR::Type *translate (AST::Type *type);
+  static HIR::Type *translate (AST::Type *type,
+			       bool default_to_static_lifetime = false);
 
   void visit (AST::BareFunctionType &fntype) override;
   void visit (AST::TupleType &tuple) override;
@@ -79,7 +80,14 @@ public:
   void visit (AST::TraitObjectType &type) override;
 
 private:
-  ASTLoweringType () : ASTLoweringBase (), translated (nullptr) {}
+  ASTLoweringType (bool default_to_static_lifetime)
+    : ASTLoweringBase (),
+      default_to_static_lifetime (default_to_static_lifetime),
+      translated (nullptr)
+  {}
+
+  /** Used when compiling const and static items. */
+  bool default_to_static_lifetime;
 
   HIR::Type *translated;
 };